<template>
    <div v-if="afficher">
        <div class="canvas-container" id="canvasContainer">
            <canvas id="canvas"></canvas>
            <canvas id="canvasTop"></canvas>
        </div>
        <div class="uk-margin uk-flex uk-flex-center">
            <span uk-icon="icon: triangle-up; ratio: 2.5" @click="actionUp()" />
            <span
                uk-icon="icon: triangle-down; ratio: 2.5"
                @click="actionDown()"
            />
            <span
                uk-icon="icon: triangle-left; ratio: 2.5"
                @click="actionLeft()"
            />
            <span
                uk-icon="icon: triangle-right; ratio: 2.5"
                @click="actionRight()"
            />
        </div>
    </div>
</template>

<script lang="ts">
import CreationArbre from './CreationArbre';
import Possibilite from '../../classes/Possibilite';
import Noeud, { ResultatNoeudPossible } from './Noeud';
import Vue from 'vue';
import { Component, Prop } from 'vue-property-decorator';
import { getInstanceEtatEdition } from '@/views/Enseignement/editerprobleme/EtatEdition';

export const RADIUS = 10;
export const MARGIN_X = 14;
export const MARGIN_Y = 20;
export const INITIAL_X = 35;
export const INITIAL_Y = 35;

@Component
export default class PossibilitesCanvas extends Vue {
    @Prop() afficher: boolean;
    @Prop() avecCouleurPossibilite: boolean;

    private etatEdition: any;
    private nodes: Noeud[];
    private canvas: HTMLCanvasElement;
    private ctx: CanvasRenderingContext2D;
    private canvasTop: HTMLCanvasElement;
    private ctxTop: CanvasRenderingContext2D;
    private longestPossibility: number;
    private nodesPositions: Array<{ node: Noeud; x: number; y: number }>;
    private initialStoneColor: string;
    private currentNode: { x: number; y: number };
    private lowestY: number;
    private clickHandler: (event: MouseEvent) => void;

    created() {
        this.etatEdition = getInstanceEtatEdition();
        this.$root.$on('modifierPosition', () => {
            if (this.etatEdition.isDetail()) {
                this.select({
                    x: this.etatEdition.getIndexPossibilite(),
                    y: this.etatEdition.getIndexPierre()
                });
            }
        });
        this.$root.$on('initPosition', () => {
            this.init();
        });
    }

    updated() {
        if (this.afficher) {
            this.canvas = document.getElementById(
                'canvas'
            ) as HTMLCanvasElement;
            this.ctx = this.canvas.getContext('2d');
            this.canvasTop = document.getElementById(
                'canvasTop'
            ) as HTMLCanvasElement;
            this.ctxTop = this.canvasTop.getContext('2d');
            this.ctx.lineWidth = 2;
            this.ctxTop.lineWidth = 2;
            this.clickHandler = this.onClick.bind(this);
            this.canvasTop.addEventListener('click', this.clickHandler);
            this.init();
        }
    }

    private getCurrentMove(): { x: number; y: number } {
        return {
            x: this.etatEdition.getIndexPossibilite(),
            y: this.etatEdition.getIndexPierre()
        };
    }

    private onClick(event: MouseEvent) {
        if (
            event.offsetX >= INITIAL_X - RADIUS &&
            event.offsetX <= INITIAL_X + RADIUS &&
            event.offsetY >= INITIAL_Y - RADIUS &&
            event.offsetY <= INITIAL_Y + RADIUS
        ) {
            this.goTo(this.currentNode.x, -1);
            return;
        }
        for (const pos of this.nodesPositions) {
            if (
                event.offsetX >= pos.x - RADIUS &&
                event.offsetX <= pos.x + RADIUS &&
                event.offsetY >= pos.y - RADIUS &&
                event.offsetY <= pos.y + RADIUS
            ) {
                const y = pos.node.getIndex();
                let x = pos.node.getPossibilites()[0];
                if (this.currentNode) {
                    const xIndex = pos.node
                        .getPossibilites()
                        .indexOf(this.currentNode.x);
                    if (xIndex !== -1) {
                        x = pos.node.getPossibilites()[xIndex];
                    }
                }
                this.goTo(x, y);
                return;
            }
        }
    }

    private goTo(x: number, y: number) {
        this.$root.$emit('enregistrerCommentaire');
        this.etatEdition.goTo(x, y);
        this.$root.$emit('modifierPosition', true);
    }

    private drawBase(ctx: CanvasRenderingContext2D, isTopCanvas = false) {
        ctx.clearRect(0, 0, ctx.canvas.width, ctx.canvas.height);
        ctx.fillStyle = `rgba(250, 235, 215, ${isTopCanvas ? 0.7 : 1})`;
        ctx.fillRect(0, 0, ctx.canvas.width, ctx.canvas.height);
    }

    private drawCanvas(ctx: CanvasRenderingContext2D, isTopCanvas = false) {
        const x = INITIAL_X;
        const y = INITIAL_Y;
        this.lowestY = INITIAL_Y;

        this.drawBase(ctx, isTopCanvas);
        if (this.nodes.length > 0) {
            this.nodes.forEach((node, index) => {
                this.drawTrack(ctx, node, x, y, index === 0, isTopCanvas);
            });

            this.lowestY = y;
            this.nodes.forEach((node, index) => {
                this.drawStones(
                    ctx,
                    node,
                    x + MARGIN_X + RADIUS * 2,
                    index === 0
                        ? this.lowestY
                        : this.lowestY + (MARGIN_Y + RADIUS),
                    isTopCanvas
                );
            });
        }
    }

    private getStoneColor(isOdd: number): string {
        if (this.initialStoneColor === 'NOIR') {
            return isOdd ? '#000000' : '#ffffff';
        } else {
            return isOdd ? '#ffffff' : '#000000';
        }
    }

    private paintStone(
        ctx: CanvasRenderingContext2D,
        x: number,
        y: number,
        fillStyle: string
    ) {
        ctx.beginPath();
        ctx.moveTo(x, y);
        ctx.arc(x, y, RADIUS, 0, Math.PI * 2);
        ctx.strokeStyle = '#000000';
        ctx.stroke();
        ctx.fillStyle = fillStyle;
        ctx.fill();
    }

    private drawTrack(
        ctx: CanvasRenderingContext2D,
        node: Noeud,
        originX: number,
        originY: number,
        isFirst: boolean,
        isTopCanvas: boolean
    ) {
        const x = originX + MARGIN_X + RADIUS * 2;
        const y = isFirst ? this.lowestY : this.lowestY + (MARGIN_Y + RADIUS);
        this.lowestY = this.lowestY < y ? y : this.lowestY;
        if (isTopCanvas === false || this.isCurrentOrBefore(node)) {
            ctx.strokeStyle = this.avecCouleurPossibilite
                ? this.definirCouleurSelonResultat(node)
                : '#000000';
            ctx.beginPath();
            ctx.moveTo(originX, originY);
            ctx.lineTo(originX, y);
            ctx.lineTo(x, y);
            ctx.stroke();
        }
        node.getNoeudsSuivants().forEach((nextNode, index) => {
            this.drawTrack(ctx, nextNode, x, y, index === 0, isTopCanvas);
        });
    }

    private definirCouleurSelonResultat(node: Noeud): string {
        switch (node.getResultat()) {
            case ResultatNoeudPossible.VALIDE:
                return '#69FC24';
            case ResultatNoeudPossible.INVALIDE:
                return '#FC2D24';
            default:
                return '#000000';
        }
    }

    private isCurrentOrBefore(node: Noeud): boolean {
        return (
            this.currentNode &&
            node.getPossibilites().indexOf(this.currentNode.x) !== -1 &&
            node.getIndex() <= this.currentNode.y
        );
    }

    private drawStones(
        ctx: CanvasRenderingContext2D,
        node: Noeud,
        x: number,
        y: number,
        isTopCanvas: boolean
    ) {
        this.lowestY = this.lowestY < y ? y : this.lowestY;

        if (isTopCanvas === false || this.isCurrentOrBefore(node)) {
            this.paintStone(ctx, x, y, this.getStoneColor(node.getIndex() % 2));
        }

        // premier draw des pierres
        if (isTopCanvas === false) {
            this.nodesPositions.push({ node, x, y });
        }

        node.getNoeudsSuivants().forEach((nextNode, index) => {
            this.drawStones(
                ctx,
                nextNode,
                x + MARGIN_X + RADIUS * 2,
                index === 0 ? this.lowestY : this.lowestY + (MARGIN_Y + RADIUS),
                isTopCanvas
            );
        });
    }

    private generateCanvas(possibilites: Possibilite[]) {
        this.longestPossibility = possibilites.reduce(
            (acc, curr) =>
                curr.getCoups().length > acc ? curr.getCoups().length : acc,
            0
        );
        this.canvas.width =
            INITIAL_X +
            (MARGIN_X + RADIUS * 2) * (this.longestPossibility + 1) +
            MARGIN_X;
        if (this.canvas.width < this.canvas.parentElement.clientWidth) {
            this.canvas.width = this.canvas.parentElement.clientWidth;
        }
        this.canvas.height =
            INITIAL_Y + (MARGIN_Y + RADIUS * 2) * (possibilites.length - 1);
        if (this.canvas.height < this.canvas.parentElement.clientHeight) {
            this.canvas.height = this.canvas.parentElement.clientHeight;
        }
        this.canvasTop.width = this.canvas.width;
        this.canvasTop.height = this.canvas.height;
    }

    public init() {
        const possibilites = this.etatEdition.possibilites;
        const initialColor = 'BLANC';
        const currentStone = this.getCurrentMove();
        if (this.afficher) {
            this.nodes =
                possibilites.length > 0
                    ? new CreationArbre().creer(possibilites)
                    : [];
            this.nodesPositions = [];
            this.generateCanvas(possibilites);
            this.initialStoneColor = initialColor;

            this.drawCanvas(this.ctx);
            this.select(currentStone);
            this.scrollToStone(currentStone);
        }
    }

    private scrollToStone(currentStone?: { x: number; y: number }) {
        const canvasContainer = document.getElementById(
            'canvasContainer'
        ) as HTMLElement;
        const currentPosition = this.nodesPositions.find(
            position =>
                position.node.getPossibilites().indexOf(currentStone.x) !==
                    -1 && position.node.getIndex() === currentStone.y
        );
        if (currentPosition) {
            canvasContainer.scrollLeft =
                currentPosition.x - canvasContainer.clientWidth + MARGIN_X;
            canvasContainer.scrollTop =
                currentPosition.y - canvasContainer.clientHeight + MARGIN_Y;
        }
    }

    public select(currentStone: { x: number; y: number }) {
        this.currentNode = currentStone;
        this.drawCanvas(this.ctxTop, true);
        this.paintStone(this.ctxTop, INITIAL_X, INITIAL_Y, '#C0C0C0');
    }

    public destroy() {
        this.canvas.removeEventListener('click', this.clickHandler);
    }

    private actionUp() {
        this.$emit('actionUp');
    }

    private actionDown() {
        this.$emit('actionDown');
    }

    private actionLeft() {
        this.$emit('actionLeft');
    }

    private actionRight() {
        this.$emit('actionRight');
    }
}
</script>

<style scoped>
* {
    margin: 0;
    padding: 0;
    box-sizing: border-box;
}

.canvas-container {
    height: 200px;
    width: 95%;
    overflow: auto;
    margin: 0 auto;
    position: relative;
    border: 1px solid #e5e5e5;
}

.canvas-container canvas {
    max-width: none;
}

#canvasTop {
    position: absolute;
    top: 0;
    left: 0;
}
</style>
